Imports FarPoint.Win.Spread

Public Class svOrders
    Inherits FarPoint.Win.Spread.SheetView

    Sub New()
        RowHeaderAutoText = FarPoint.Win.Spread.HeaderAutoText.Blank

        ColumnCount = 5
        Columns(0).Label = "OrderNo"
        Columns(1).Label = "Description"
        Columns(1).Width = 200
        Columns(2).Label = "Field 3"
        Columns(3).Label = "Field 4"
        Columns(4).Label = "Field 5"

    End Sub

    Public Overrides ReadOnly Property ChildRelationCount() As Integer
        Get
            Return 1
        End Get
    End Property

    Public Overrides Function GetChildRelation(ByVal index As Integer) As String
        Return String.Empty
    End Function

    Public Overrides ReadOnly Property ParentRowIndex() As Integer
        Get
            Return CInt(SheetName)
        End Get
    End Property

    Public Overrides Function GetChildView(ByVal row As Integer, ByVal relationIndex As Integer) As FarPoint.Win.Spread.SheetView
        Dim child As KstView = CType(FindChildView(row), KstView)

        If Not (child Is Nothing) Then Return child

        child = New KstView
        child.Parent = CType(Me, FarPoint.Win.Spread.SheetView)
        child.SheetName = row.ToString

        ChildViews.Add(child)

        Return child
    End Function

    Public Overloads Function FindChildView(ByVal row As Integer) As FarPoint.Win.Spread.SheetView
        Dim id As String = row.ToString
        Dim view As FarPoint.Win.Spread.SheetView
        For Each view In ChildViews
            If view.SheetName = id Then Return view
        Next

        Return Nothing

    End Function


End Class

Public Class KstView
    Inherits FarPoint.Win.Spread.SheetView

    Sub New()
        RowCount = Kst.GetUpperBound(0) + 1
        ColumnCount = 3
        Columns(0).Label = "Kst"
        Columns(1).Label = "Description"
        Columns(1).Width = 100
        Columns(2).Label = "Value"
        Dim ct As New FarPoint.Win.Spread.CellType.NumberCellType
        ct.DecimalPlaces = 2
        Columns(2).Label = "Value"
        Columns(2).CellType = ct

        For intcnt As Integer = 0 To Kst.GetUpperBound(0)
            Cells(intcnt, 0).Value = Kst(intcnt)
            Cells(intcnt, 1).Value = KstName(intcnt)
        Next

        Me.OperationMode = FarPoint.Win.Spread.OperationMode.Normal
        RowHeaderAutoText = FarPoint.Win.Spread.HeaderAutoText.Blank

        'Me.RowHeader.Visible = False
        'Me.ColumnHeader.Visible = False
        AddHandler CellChanged, AddressOf Kst_Cellchanged

    End Sub

    Private Sub Kst_Cellchanged(ByVal sender As Object, ByVal e As SheetViewEventArgs)
        Dim t As Decimal = 0
        If e.Column = 2 Then
            For introw As Integer = 0 To Me.RowCount - 1
                If Not IsNothing(Cells(introw, 2).Value) Then t += Cells(introw, 2).Value
            Next

            If Not Parent Is Nothing Then
                Me.Parent.Cells(Me.ParentRowIndex, 2).Value = t
            End If
        End If
    End Sub

    Public Overrides Function GetChildView(ByVal row As Integer, ByVal relationIndex As Integer) As FarPoint.Win.Spread.SheetView
        Return Nothing
    End Function

    Public Overloads Function FindChildView(ByVal row As Integer) As FarPoint.Win.Spread.SheetView
        Return Nothing
    End Function

End Class
